from mmc.core.version import scmRevision
from mmc.support.config import PluginConfig
from mmc.support.mmctools import shLaunch
from mmc.plugins.vlan.interfaces import Vlan
import logging

VERSION = "0.6.2"
APIVERSION = "1:1:0"
REVISION = scmRevision("$Rev$")


def getVersion(): return VERSION
def getApiVersion(): return APIVERSION
def getRevision(): return REVISION

def activate(): 
    config = VlanConfig("vlan")
    logger = logging.getLogger()
    if config.disabled:
        msg="disabled by configuration"
        logger.warning("Plugin vlan: " + msg + ".")
        return False
    msg=""
    return True

# FIXME
# Is needed this?
class VlanConfig(PluginConfig):

    def readConf(self):
        PluginConfig.readConf(self)
    def setDefault(self):
        PluginConfig.setDefault(self)


# XML-RPC remote methods
def getInterfaces():
    return Vlan().getInterfaces()
def setVlan(interface, addr, netaddr, vtag, comment, is_add, broadcast=None, dns=None, gateway=None):
    return Vlan().setVlan(interface, addr, netaddr, vtag, comment, is_add, broadcast, dns, gateway)
def getVlan(filter = ""):
    return Vlan().getVlan(filter)
def getVlanid(vlan_id):
    return Vlan().getVlanid(vlan_id)
def convertToCIDR(netmask):
    return Vlan().convertToCIDR(netmask)
def removeVlan(vlan_id):
    Vlan().removeVlan(vlan_id)
