from mmc.support.mmctools import shLaunch
from mmc.plugins.services import restart
from socket import inet_ntoa
from struct import pack
import os
import string
import re
from netaddr import IPAddress, IPNetwork
import glob



class Vlan(object):
    # Get interfaces that is not virtual
    def getInterfaces(self):
        inter = '/etc/shorewall/interfaces'
        lines = open(inter, "r" ).readlines()
        for line in lines:
            if re.search( r'^lan', line ):
                d = line.split()[1]
                return [d]
    # Write a file in network-scripts with the desired vlan and start the vlan (the order of the data is important to display this information)
    def setVlan(self, interface, addr, netaddr, vtag, comment, is_add, broadcast=None, dns=None, gateway=None):
        file_path = '/etc/sysconfig/network-scripts/ifcfg-'
        if( self.testIPtoSubnet(addr) ): #if exists this IP address exists in others subnets creater before
            return 7
        if( not os.path.isfile(file_path + interface + '.' + vtag)):
            self.downVlan(interface + '.' +vtag) #down vlan if the user is  editing
            def convertCIDR(netaddr): # convert CIDR to normal netaddress
                bits = 0xffffffff ^ (1 << 32 - int(netaddr)) - 1
                return inet_ntoa(pack('>I', bits))
            vlan = open(file_path + interface + '.' + vtag,'w+')
            vlan.write('DEVICE='+interface+"."+vtag + "\n")
            vlan.write('BOOTPROTO=static\n')
            vlan.write('ONBOOT=yes\n')
            vlan.write('IPADDR='+addr +'\n')
            netaddr = convertCIDR(netaddr)
            if dns:
                vlan.write('DNS1=' + dns + '\n')
            if gateway:
                vlan.write('GATEWAY=' + gateway + '\n')
            vlan.write('NETMASK='+netaddr+'\n')
            if broadcast:
                vlan.write('BROADCAST='+broadcast+'\n')
            vlan.write('VLAN=yes\n')
            vlan.write('#COMMENT='+ comment)
            vlan.close()
	        #Interfaces
    	    shorewall_interface_path = '/etc/shorewall/interfaces'
    	    shorewallinterface = open(shorewall_interface_path,'a+')
    	    shorewallinterface.write('lan'+vtag+" "+interface+"."+vtag+" "+"detect"+"\n")
    	    shorewallinterface.close()
    	    #Zones
    	    shorewallzones_path= '/etc/shorewall/zones'
    	    shorewallzones = open(shorewallzones_path,'a+')
    	    shorewallzones.write('lan'+vtag+" "+"ipv4"+"\n")
    	    shorewallzones.close()
    	    #Policy
            wan_id = shLaunch("grep -Ei '^wan[0-9]+ .*detect$' /etc/shorewall/interfaces | cut -d ' ' -f 1")
            return 1
            wan_id = wan_id.out.rstrip('\n')
            wan_id = re.sub(r'[a-zA-Z]+', '', wan_id) #get interface id only. 'wan0' = '0'
            shorewallpolicy_path = ("/etc/shorewall/policy")
            lines = file(shorewallpolicy_path, 'r').readlines() 
            last_line = lines[-1]
            del lines[-1] 
            print lines 
            file(shorewallpolicy_path, 'w').writelines(lines) 
    	    shorewallpolicy = open(shorewallpolicy_path,'a+')
            shorewallpolicy.write("lan"+vtag+"\t"+"fw"+"\t"+"DROP"+"\n")
            shorewallpolicy.write("lan"+vtag+"\t"+"wan"+wan_id+"\t"+"ACCEPT"+"\n")
            shorewallpolicy.write("wan"+wan_id+"\t"+"lan"+vtag+"\t"+"DROP"+"\n")
            shorewallpolicy.write(last_line)
            shorewallpolicy.close()
            self.upVlan(interface + '.' + vtag)
            #Shorewall Log Prefix limit fix (if vlan id up to 99 shorewall brokes, because have a log limit)
            if (vtag > 99):
                swconf_path='/etc/shorewall/shorewall.conf'
                f = open(swconf_path, 'r')
                lines = [ n for n in f.readlines() if not re.match("LOGFORMAT", n)]
                open(swconf_path, "w").write("".join(lines))
                f = open(swconf_path, 'a+')
                f.write('LOGFORMAT="fw:%s:%s:"')
                f.close()
            return 1
        else: # could not write the file because it already exists
            return 2
    # Get VLAN configuration
    def getVlan(self, filter = ""):
        if filter: #case Insensitive!
            filter=filter.lower()
            
        # array declarations
        interfacesFiles = []
        interfacesArray = []
        # path interfaces
        interfacesPath = '/etc/sysconfig/network-scripts/'
        # validating vlan interfaces
        interfacesEr = r'^ifcfg-[a-zA-Z0-9]+\.[0-9]+$'

        # list all vlan interfaces
        interfacesFiles += [each for each in os.listdir(interfacesPath) if re.search(interfacesEr,each)]

        # create a structured array with vlan name and his properties
        # array structure:
        # [[vlan name1, [arg1,arg2,arg3]], [vlan name2, [arg1,arg2,arg3]], ...]
        # first vector: store all vlan interfaces
        # second vector: each vlan name + his properties
        # third vector: vlan properties 
        for interfaceFile in interfacesFiles:
            # get vlan name
            vlan = interfaceFile.split('-')[1]
            # get vlan properties from interface file and remove new line character
            interfaceData = list(open(interfacesPath + interfaceFile, 'r'))
            interfaceData = [line.rstrip('\n') for line in interfaceData]
            # append vlan interfaces in vlans array. If filter is set, then apply filter
            if filter and ((filter in interfaceData[0].lower()) or (filter in interfaceData[3].lower())):
                interfacesArray.append(list((vlan,interfaceData)))
            elif not filter: #filter not set
                interfacesArray.append(list((vlan,interfaceData)))
             
        # return vlans array
        return interfacesArray
        
    #Get only the VLAN interface especified in vlan_id (e.g. eth0.1,eth0.2)
    def getVlanid(self,vlan_id):
        interfacePath = '/etc/sysconfig/network-scripts/ifcfg-'
        interfaceData = list(open(interfacePath + vlan_id, 'r'))
        interfaceData = [line.rstrip('\n') for line in interfaceData]
        return interfaceData
        
    #Method to convert netmask addr to CIDR notation
    def convertToCIDR(self, netmask):
        subnet = netmask
        (octet1,octet2,octet3,octet4) = subnet.split(".")
        octet1 = int(octet1)
        octet2 = int(octet2)
        octet3 = int(octet3)
        octet4 = int(octet4)

        worker = octet1
        count = 0
        while worker != 0:
            if worker % 2 == 1:
                    count = count + 1
            worker = worker/2

        worker = octet2
        while worker != 0:
            if worker % 2 == 1:
                count = count +1
            worker = worker/2
        worker = octet3
        while worker != 0:
            if worker % 2 == 1:
                count = count +1
            worker = worker/2
        worker = octet4
        while worker != 0:
            if worker % 2 == 1:
                count= count+1
            worker = worker/2
        return count
    # Set VLAN Online and Offline
    def upVlan(self, vlan_id):
        shLaunch("ifup " + vlan_id)
    def downVlan(self, vlan_id):
        shLaunch("ifdown " + vlan_id)

    # Remove VLAN
    def removeVlan(self, vlan_id):
        interfacePath = '/etc/sysconfig/network-scripts/ifcfg-' + vlan_id
        self.downVlan(vlan_id)
        os.remove(interfacePath)
        # remove the shorewall rules and other user defined rules about this vlan
        vid = string.split(vlan_id, '.')
        vid = vid[1]
        #Remove shorewall zones matching vlan
    	swzones_path = '/etc/shorewall/zones'
        f = open(swzones_path, 'r')
        lines = [n for n in f.readlines() if not n.startswith('lan'+vid)]
        open(swzones_path, "w").write("".join(lines))
        #Remove shorewall interfaces matching vlan
        swinterf_path = '/etc/shorewall/interfaces'
        f = open(swinterf_path, 'r')
        lines = [n for n in f.readlines() if not n.startswith('lan'+vid)]
        open(swinterf_path, "w").write("".join(lines))
        #Remove shorewall policy matching vlan
        swpolicy_path='/etc/shorewall/policy'
        f = open(swpolicy_path, 'r')
        lines = [ n for n in f.readlines() if not re.match("(.*)lan" + vid + "(.*)", n)]
        open(swpolicy_path, "w").write("".join(lines))
        #Remove shorewall rules 
        swrules_path='/etc/shorewall/rules'
        f = open(swrules_path, 'r')
        lines = [ n for n in f.readlines() if not re.match("(.*)lan" + vid + "(.*)", n)]
        open(swrules_path, "w").write("".join(lines))
        #Remove shorewall masq
        swmasq_path='/etc/shorewall/masq'
        f = open(swmasq_path, 'r')
        lines = [ n for n in f.readlines() if not re.match("(.*)" + vlan_id + "(.*)", n)]
        open(swmasq_path, "w").write("".join(lines))
        restart("shorewall")

    #Test if the address passed exists in any other vlans subnets
    #return True if exists
    def testIPtoSubnet(self, addr):
        vlan_files=glob.glob("/etc/sysconfig/network-scripts/ifcfg-eth[0-9]*.[0-9]*")
        if not vlan_files: #no configurations found so accept
            return False
        ip_mask= [[],[]]# position 0 = ip position 1 = netmask
        for conf in vlan_files:
            file_vlan = open(conf, 'r')
            for line in file_vlan:
                if re.match('^IPADDR.*',line):
                    ip = line.split('=')
                    ip = ip[1]
                    ip = ip.rstrip()
                    ip_mask[0].append(ip)
                elif re.match('^NETMASK.*',line):
                    mask = line.split('=')
                    mask = mask[1]
                    mask = mask.rstrip()
                    ip_mask[1].append(mask)
            file_vlan.close()
        for i in range(len(ip_mask[0])):
            if IPAddress(addr) in IPNetwork(ip_mask[0][i]+'/'+ip_mask[1][i]):
                return True
        return False
